/*
			 CLEPTROJAN
			By Croconauts
*/

// ---- Librerias y definiciones ---- //

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "sprites.h"

#define TILE_ALTURA 10	
#define TILE_ANCHURA 8	
#define MODO0_ALTURA 200
#define MODO0_ANCHURA 160
#define N_TILES_ANCHO MODO0_ANCHURA / TILE_ANCHURA
#define N_TILES_ALTO MODO0_ALTURA / TILE_ALTURA
#define N_COLORES 16

// ---- Enumeradores ---- //

enum TileTipo
{
  TileTipo_Chip,
  TileTipo_EnemMiraArriba,
  TileTipo_EnemMiraAbajo,
  TileTipo_EnemMiraIzq,
  TileTipo_EnemMiraDer,
  TileTipo_PjMiraArriba,
  TileTipo_PjMiraAbajo,
  TileTipo_PjMiraIzq,
  TileTipo_PjMiraDer,
  TileTipo_Pared,
  TileTipo_Suelo,
  TileTipo_Vacio,
  TileTipo_Portal
}TileTipo;

enum TileTipo aBackgroundTiles[N_TILES_ANCHO][N_TILES_ALTO]; 
enum TileTipo tileTipo = TileTipo_PjMiraDer;

enum Direcciones
{
	Direccion_Arriba,
	Direccion_Abajo,
	Direccion_Izq,
	Direccion_Der,
	Direccion_Ninguna      
}Direcciones;

enum Direcciones direccion = Direccion_Ninguna;


// ---- Estructuras ---- //

typedef struct Personaje
{
	unsigned char pX;
	unsigned char pY;
}Personaje;

typedef struct Enemigo    
{
	unsigned char eX;
	unsigned char eY;
	int iterarTiempo;
	enum Direcciones enemDirBuena;
	enum Direcciones enemDirUsada;
	enum TileTipo enemTile;
	int posXFijada;
	int posYFijada;
	int velocidad;
}Enemigo;


// ---- Variables Globales ---- //

Enemigo enemigos[7];  
Personaje personaje;
int joya;       
int puntos = 0;     
int salirJuego = -1;
int tieneJoya = 0;
int r = -1; 
int i = 0; 
int n = 0;
unsigned char char3,char4;
char nGetChar;
char bPrimeraVez = '1';

const unsigned char Mapa[N_TILES_ANCHO][N_TILES_ALTO] = {
	{3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
	{3, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 2, 1},
	{3, 1, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1},
	{3, 1, 1, 1, 0, 1, 1, 1, 1, 1, 2, 1, 0, 1, 1, 1, 0, 1, 0, 1},
	{3, 1, 2, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1},
	{3, 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1},
	{3, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1},
	{3, 1, 0, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1},
	{3, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1},
	{3, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1},
	{3, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 0},
	{3, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1},
	{3, 1, 0, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1},
	{3, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1},
	{3, 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1},
	{3, 1, 2, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1},
	{3, 1, 1, 1, 0, 1, 1, 1, 1, 1, 2, 1, 0, 1, 1, 1, 0, 1, 0, 1},
	{3, 1, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1},
	{3, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 2, 1},
	{3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
};


// ---- Declaracion de Funciones ---- //

void InicializarJuego();
int EnemigoIA(int numEnem);
void EnemigoMover(int numEnem);
void Teclado();
unsigned char MoverPj();
void Juego();
void MostrarIntro();
void MostrarIntroCleptrojan();
void MostrarInstrucciones();
unsigned int GetTime();
char GetChar();
void PutSpriteMode0(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite);
void DrawTile(unsigned char nTileX, unsigned char nTileY);
void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex);
void SetMode(unsigned char nMode);
void SetCursor(unsigned char nColum, unsigned char nLine);
void SetPalette(const unsigned char *pPalette);
void InitMode0();


// ---- Main ---- //

void main()
{
  MostrarIntro();

  MostrarIntroCleptrojan();

  MostrarInstrucciones();

  while(1)
  {
    Juego();
  }
}

// ---- Funciones ---- //

//InicializarJuego
void InicializarJuego()
{
	unsigned char nColor = 0;
	unsigned int pX = 0;
	unsigned int pY = 0;

	joya = 0;                  
	puntos = 0;                
	tileTipo = TileTipo_PjMiraDer;

	SetPalette(Palette);

	salirJuego = 0; 

	for(nColor = 0; nColor < N_COLORES; nColor++)
		SetColor(nColor, Palette[nColor]);

	for(pX = 0; pX < N_TILES_ANCHO; pX++)
	{
		for(pY = 0; pY < N_TILES_ALTO; pY++)
		{		
			if(Mapa[pX][pY] == 0)
			{
				aBackgroundTiles[pX][pY] = TileTipo_Suelo;
			}
			else if(Mapa[pX][pY] == 1)
			{
				aBackgroundTiles[pX][pY] = TileTipo_Pared;
			}
			else if(Mapa[pX][pY] == 2)
			{
				aBackgroundTiles[pX][pY] = TileTipo_Vacio;
			}
			else
			{
				aBackgroundTiles[pX][pY] = TileTipo_Portal;
			}
		}
	}

	direccion = Direccion_Ninguna;
	personaje.pX = 10;
	personaje.pY = 18;

	enemigos[0].enemDirBuena = Direccion_Der; 
	enemigos[0].enemDirUsada = Direccion_Izq;
	enemigos[0].eX = 9;    
	enemigos[0].eY = 14;   
	enemigos[0].iterarTiempo = 0;

	enemigos[1].enemDirBuena = Direccion_Der;  
	enemigos[1].enemDirUsada = Direccion_Izq;  
	enemigos[1].eX = 2;    
	enemigos[1].eY = 16;   

	enemigos[2].enemDirBuena = Direccion_Izq;  
	enemigos[2].enemDirUsada = Direccion_Der;  
	enemigos[2].eX = 17;    
	enemigos[2].eY = 16;   

	enemigos[3].enemDirBuena = Direccion_Der;  
	enemigos[3].enemDirUsada = Direccion_Izq;  
	enemigos[3].eX = 10;    
	enemigos[3].eY = 12;   

	enemigos[4].enemDirBuena = Direccion_Arriba;  
	enemigos[4].enemDirUsada = Direccion_Abajo;  
	enemigos[4].eX = 1;    
	enemigos[4].eY = 10;   

	enemigos[5].enemDirBuena = Direccion_Abajo;  
	enemigos[5].enemDirUsada = Direccion_Arriba;  
	enemigos[5].eX = 18;    
	enemigos[5].eY = 10;   

	enemigos[6].enemDirBuena = Direccion_Der;  
	enemigos[6].enemDirUsada = Direccion_Izq;  
	enemigos[6].eX = 10;    
	enemigos[6].eY = 2;   

	for(n = 0; n < 7; n++)
	{
		enemigos[n].iterarTiempo = 0;
		enemigos[n].posXFijada = 0;
		enemigos[n].posYFijada = 0;
		enemigos[n].velocidad = 5;
	}

	aBackgroundTiles[personaje.pX][personaje.pY] = TileTipo_PjMiraDer;
	aBackgroundTiles[enemigos[0].eX][enemigos[0].eY] = TileTipo_EnemMiraIzq;

	for(pX = 0; pX < N_TILES_ANCHO; pX++)
	{
		for(pY = 0; pY < N_TILES_ALTO; pY++)
		{
			DrawTile(pX, pY);
		}
	}
}

// Enemigo
int EnemigoIA(int numEnem)
{
	int nDir = 0;

	int salirWhile = 0;

	enum Direcciones auxCamino;

	if(enemigos[numEnem].iterarTiempo == 5)
	{
		if(aBackgroundTiles[enemigos[numEnem].eX+1][enemigos[numEnem].eY] != TileTipo_Pared) // Der
		{
			nDir++;
			if (enemigos[numEnem].enemDirUsada != Direccion_Der)
				auxCamino = Direccion_Der;
		}

		if(aBackgroundTiles[enemigos[numEnem].eX-1][enemigos[numEnem].eY] != TileTipo_Pared) // Izq
		{
			nDir++;
			if (enemigos[numEnem].enemDirUsada != Direccion_Izq)
				auxCamino = Direccion_Izq;
		}

		if(aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY+1] != TileTipo_Pared) // Abajo
		{
			nDir++;
			if (enemigos[numEnem].enemDirUsada != Direccion_Abajo && enemigos[numEnem].eY != 19)
				auxCamino = Direccion_Abajo;
		}

		if(aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY-1] != TileTipo_Pared) // Arriba
		{
			nDir++;
			if (enemigos[numEnem].enemDirUsada != Direccion_Arriba || enemigos[numEnem].eY == 19)
				auxCamino = Direccion_Arriba;
			if (enemigos[numEnem].eY == 19)
				nDir = 1;
		}

		if (nDir == 1)
		{
			enum Direcciones auxDirection;

			auxDirection = enemigos[numEnem].enemDirUsada;
			enemigos[numEnem].enemDirUsada = enemigos[numEnem].enemDirBuena;
			enemigos[numEnem].enemDirBuena = auxDirection;
		}

		else if (nDir == 2)
		{
			enemigos[numEnem].enemDirBuena = auxCamino;

			if (enemigos[numEnem].enemDirBuena == Direccion_Arriba)
				enemigos[numEnem].enemDirUsada = Direccion_Abajo;

			else if (enemigos[numEnem].enemDirBuena == Direccion_Der)
				enemigos[numEnem].enemDirUsada = Direccion_Izq;

			else if (enemigos[numEnem].enemDirBuena == Direccion_Izq)
				enemigos[numEnem].enemDirUsada = Direccion_Der;

			else
				enemigos[numEnem].enemDirUsada = Direccion_Arriba;
		}

		else if (nDir > 2)
		{
			while (salirWhile == 0)
			{
				r = rand() % 4;

				if (r != enemigos[numEnem].enemDirUsada)
				{
					if (r == 0 && aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY-1] != TileTipo_Pared)
					{
						enemigos[numEnem].enemDirBuena = Direccion_Arriba;
						enemigos[numEnem].enemDirUsada = Direccion_Abajo;
						salirWhile = 1;

					}
					else if (r == 1 && aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY+1] != TileTipo_Pared)
					{
						enemigos[numEnem].enemDirBuena = Direccion_Abajo;
						enemigos[numEnem].enemDirUsada = Direccion_Arriba;
						salirWhile = 1;
					}
					else if (r == 2 && aBackgroundTiles[enemigos[numEnem].eX-1][enemigos[numEnem].eY] != TileTipo_Pared)
					{
						enemigos[numEnem].enemDirBuena = Direccion_Izq;
						enemigos[numEnem].enemDirUsada = Direccion_Der;
						salirWhile = 1;
					}
					else if (r == 3 && aBackgroundTiles[enemigos[numEnem].eX+1][enemigos[numEnem].eY] != TileTipo_Pared)
					{
						enemigos[numEnem].enemDirBuena = Direccion_Der;
						enemigos[numEnem].enemDirUsada = Direccion_Izq;
						salirWhile = 1;
					}
				}

			}
		}

		enemigos[numEnem].iterarTiempo = 0;
		return 1;
	}
	else
	{
		enemigos[numEnem].iterarTiempo++;
		return 0;
	}
}

// EnemigoMover
void EnemigoMover(int numEnem)
{
	aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY] = TileTipo_Suelo;

	switch(enemigos[numEnem].enemDirBuena)
	{
	case Direccion_Der:
		if(enemigos[numEnem].eY == enemigos[numEnem].posYFijada && enemigos[numEnem].eX == enemigos[numEnem].posXFijada)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
		}

		else if ( enemigos[numEnem].posXFijada != 0 && aBackgroundTiles[enemigos[numEnem].eX+1][enemigos[numEnem].eY] ==  TileTipo_Pared)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
			break;
		}

		DrawTile(enemigos[numEnem].eX, enemigos[numEnem].eY);
		enemigos[numEnem].eX++;
		enemigos[numEnem].enemTile = TileTipo_EnemMiraDer;

		break;

	case Direccion_Izq:


		if(enemigos[numEnem].eY == enemigos[numEnem].posYFijada && enemigos[numEnem].eX == enemigos[numEnem].posXFijada)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
		}

		else if (enemigos[numEnem].posXFijada != 0 &&aBackgroundTiles[enemigos[numEnem].eX-1][enemigos[numEnem].eY] ==  TileTipo_Pared)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
			break;
		}

		DrawTile(enemigos[numEnem].eX, enemigos[numEnem].eY);
		enemigos[numEnem].eX--;
		enemigos[numEnem].enemTile = TileTipo_EnemMiraIzq;

		break;

	case Direccion_Arriba:
		if(enemigos[numEnem].eY == enemigos[numEnem].posYFijada && enemigos[numEnem].eX == enemigos[numEnem].posXFijada)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
		}

		else if (enemigos[numEnem].posXFijada != 0 && aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY-1] ==  TileTipo_Pared)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
			break;
		}

		DrawTile(enemigos[numEnem].eX, enemigos[numEnem].eY);
		enemigos[numEnem].eY--;
		enemigos[numEnem].enemTile = TileTipo_EnemMiraArriba;

		break;

	case Direccion_Abajo:
		if(enemigos[numEnem].eY == enemigos[numEnem].posYFijada && enemigos[numEnem].eX == enemigos[numEnem].posXFijada)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
		}

		else if (enemigos[numEnem].posXFijada != 0 && aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY+1] ==  TileTipo_Pared)
		{
			enemigos[numEnem].posXFijada = 0;
			enemigos[numEnem].posYFijada = 0;
			break;
		}

		DrawTile(enemigos[numEnem].eX, enemigos[numEnem].eY);
		enemigos[numEnem].eY++;
		enemigos[numEnem].enemTile = TileTipo_EnemMiraAbajo;

		break;
	}

	if (aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY] == TileTipo_Portal)
	{
		if (enemigos[numEnem].eX == 1 && enemigos[numEnem].eY == 18)
		{
			enemigos[numEnem].eX = 14;
			enemigos[numEnem].eX = 2;
		}
		if (enemigos[numEnem].eX == 15 && enemigos[numEnem].eY == 2)
		{
			enemigos[numEnem].eX = 2;
			enemigos[numEnem].eY = 18;
		}
		if (enemigos[numEnem].eX == 18 && enemigos[numEnem].eY == 18)
		{
			enemigos[numEnem].eX = 5;
			enemigos[numEnem].eY = 2;
		}
		if (enemigos[numEnem].eX == 4 && enemigos[numEnem].eY == 2)
		{
			enemigos[numEnem].eX = 17;
			enemigos[numEnem].eY = 18;
		}
		if (enemigos[numEnem].eX == 3 && enemigos[numEnem].eY == 10)
		{
			enemigos[numEnem].eX = 15;
			enemigos[numEnem].eY = 10;
		}
		if (enemigos[numEnem].eX == 16 && enemigos[numEnem].eY == 10)
		{
			enemigos[numEnem].eX = 4;
			enemigos[numEnem].eY = 10;
		}
	}

	aBackgroundTiles[enemigos[numEnem].eX][enemigos[numEnem].eY] = enemigos[numEnem].enemTile;
	DrawTile(enemigos[numEnem].eX, enemigos[numEnem].eY);
}

//Teclado
void Teclado()
{
	char nChar = GetChar();

	if(nChar == 'Q' || nChar == 'q' || nChar == -16) //Arriba
	{
		if(aBackgroundTiles[personaje.pX][personaje.pY-1] != TileTipo_Pared)
			direccion = Direccion_Arriba;
	}
	else if(nChar == 'A' || nChar == 'a' || nChar == -15) //Abajo
	{   
		if(aBackgroundTiles[personaje.pX][personaje.pY+1] != TileTipo_Pared && personaje.pY != 19)
			direccion = Direccion_Abajo;
	}
	else if(nChar == 'O' || nChar == 'o' || nChar == -14) //Izquierda
	{
		if(aBackgroundTiles[personaje.pX-1][personaje.pY] != TileTipo_Pared)
			direccion = Direccion_Izq;
	}
	else if(nChar == 'P' || nChar == 'p' || nChar == -13) //Derecha
	{
		if(aBackgroundTiles[personaje.pX+1][personaje.pY] != TileTipo_Pared)
			direccion = Direccion_Der;
	}
}

//MoverPj
unsigned char MoverPj()
{
	aBackgroundTiles[personaje.pX][personaje.pY] = TileTipo_Suelo;

	switch(direccion)
	{
	case Direccion_Der:
		DrawTile(personaje.pX, personaje.pY);
		personaje.pX++;
		tileTipo = TileTipo_PjMiraDer;
		break;
	case Direccion_Izq:
		DrawTile(personaje.pX, personaje.pY);
		personaje.pX--;
		tileTipo = TileTipo_PjMiraIzq;
		break;
	case Direccion_Arriba:
		DrawTile(personaje.pX, personaje.pY);
		personaje.pY--;
		tileTipo = TileTipo_PjMiraArriba;
		break;
	case Direccion_Abajo:
		DrawTile(personaje.pX, personaje.pY);
		personaje.pY++;
		tileTipo = TileTipo_PjMiraAbajo;
		break;
	case Direccion_Ninguna:
		aBackgroundTiles[personaje.pX][personaje.pY] = TileTipo_PjMiraArriba;
		break;
	}

	direccion = Direccion_Ninguna;    

	if(aBackgroundTiles[personaje.pX][personaje.pY] == TileTipo_Chip)
	{
		joya = 1;
	}

	else if (aBackgroundTiles[personaje.pX][personaje.pY] == TileTipo_Portal)
	{
		if (personaje.pX == 1 && personaje.pY == 18)
		{
			personaje.pX = 14;
			personaje.pY = 2;
		}
		if (personaje.pX == 15 &&personaje.pY == 2)
		{
			personaje.pX = 2;
			personaje.pY = 18;
		}
		if (personaje.pX == 18 && personaje.pY == 18)
		{
			personaje.pX = 5;
			personaje.pY = 2;
		}
		if (personaje.pX == 4 && personaje.pY == 2)
		{
			personaje.pX = 17;
			personaje.pY = 18;
		}
		if (personaje.pX == 3 && personaje.pY == 10)
		{
			personaje.pX = 15;
			personaje.pY = 10;
		}
		if (personaje.pX == 16 && personaje.pY == 10)
		{
			personaje.pX = 4;
			personaje.pY = 10;
		}
	}

	aBackgroundTiles[personaje.pX][personaje.pY] = tileTipo;

	DrawTile(personaje.pX, personaje.pY);

	return 1;
}

//Juego
void Juego()
{
	unsigned int nLastMoveTime = GetTime();
	unsigned int tiempoJuego = 0;
	unsigned int nJuegoSpeed = 50;
	unsigned char bGrowSnake = 0;
	unsigned short countdown = 121;

	unsigned int hayJoya = 0;
	unsigned int zonaJoya = 0;
	unsigned int joyaX = 0;
	unsigned int joyaY = 0;
	unsigned int conseguirPuntos = 1;
	unsigned int conseguirPuntosB = 1;

	srand(time(NULL));

	zonaJoya = rand() % 18;

	InitMode0();
	InicializarJuego();

	while(1)
	{
		if(hayJoya == 0)
		{
			// Posiciones Joya
			switch(zonaJoya)
			{
			case 0: 
				aBackgroundTiles[17][2] = TileTipo_Chip;
				joyaX = 17;
				joyaY = 2;
				DrawTile(17, 2);
				break;

			case 1: 
				aBackgroundTiles[2][2] = TileTipo_Chip;
				joyaX = 2;
				joyaY = 2;
				DrawTile(2, 2);
				break;

			case 2: 
				aBackgroundTiles[9][5] = TileTipo_Chip;
				joyaX = 9;
				joyaY = 5;
				DrawTile(9, 5);
				break;

			case 3: 
				aBackgroundTiles[18][6] = TileTipo_Chip;
				joyaX = 18;
				joyaY = 6;
				DrawTile(18, 6);
				break;

			case 4: 
				aBackgroundTiles[1][6] = TileTipo_Chip;
				joyaX = 1;
				joyaY = 6;
				DrawTile(1, 6);
				break;

			case 5: 
				aBackgroundTiles[11][12] = TileTipo_Chip;
				joyaX = 11;
				joyaY = 12;
				DrawTile(11, 12);
				break;

			case 6: 
				aBackgroundTiles[8][12] = TileTipo_Chip;
				joyaX = 8;
				joyaY = 12;
				DrawTile(8, 12);
				break;

			case 7: 
				aBackgroundTiles[1][14] = TileTipo_Chip;
				joyaX = 1;
				joyaY = 14;
				DrawTile(1, 14);
				break;

			case 8: 
				aBackgroundTiles[17][14] = TileTipo_Chip;
				joyaX = 17;
				joyaY = 14;
				DrawTile(17, 14);
				break;

			case 9: 
				aBackgroundTiles[9][14] = TileTipo_Chip;
				joyaX = 9;
				joyaY = 14;
				DrawTile(9, 14);
				break;

			case 10: 
				aBackgroundTiles[6][18] = TileTipo_Chip;
				joyaX = 6;
				joyaY = 18;
				DrawTile(6, 18);
				break;

			case 11: 
				aBackgroundTiles[13][18] = TileTipo_Chip;
				joyaX = 13;
				joyaY = 18;
				DrawTile(13, 18);
				break;

			case 12: 
				aBackgroundTiles[5][9] = TileTipo_Chip;
				joyaX = 5;
				joyaY = 9;
				DrawTile(5, 9);
				break;

			case 13: 
				aBackgroundTiles[14][9] = TileTipo_Chip;
				joyaX = 14;
				joyaY = 9;
				DrawTile(14, 9);
				break;

			case 14: 
				aBackgroundTiles[1][9] = TileTipo_Chip;
				joyaX = 1;
				joyaY = 9;
				DrawTile(1, 9);
				break;

			case 15: 
				aBackgroundTiles[3][9] = TileTipo_Chip;
				joyaX = 18;
				joyaY = 9;
				DrawTile(18, 9);
				break;

			case 16: 
				aBackgroundTiles[3][4] = TileTipo_Chip;
				joyaX = 3;
				joyaY = 4;
				DrawTile(3, 4);
				break;

			case 17: 
				aBackgroundTiles[16][4] = TileTipo_Chip;
				joyaX = 16;
				joyaY = 4;
				DrawTile(16, 4);
				break;
			}

		}

		//Coger joya

		if(personaje.pX == joyaX)
		{
			if(personaje.pY == joyaY)
			{
				zonaJoya = rand() % 18;
				conseguirPuntos = 1;
				tieneJoya = 1;
				hayJoya = 1;

				if(conseguirPuntosB == 1)
				{
					puntos += 25;
					countdown +=50;
					conseguirPuntosB = 0;
				}
			}
		}

		//Dejar joya

		if(personaje.pX == 10)
		{	if(personaje.pY == 19)
		{
			if (tieneJoya == 1)
			{
				if(conseguirPuntos == 1)
				{
					puntos += 50;
					countdown +=100;
					conseguirPuntos = 0;
				}

				conseguirPuntosB = 1;
				hayJoya = 0;
				tieneJoya = 0;

			}
		}
		}

		aBackgroundTiles[1][18] = TileTipo_Portal;
		DrawTile(1, 18);
		aBackgroundTiles[15][2] = TileTipo_Portal;
		DrawTile(15, 2);
		aBackgroundTiles[18][18] = TileTipo_Portal;
		DrawTile(18, 18);
		aBackgroundTiles[4][2] = TileTipo_Portal;
		DrawTile(4, 2);
		aBackgroundTiles[3][10] = TileTipo_Portal;
		DrawTile(3, 10);
		aBackgroundTiles[16][10] = TileTipo_Portal;
		DrawTile(15, 10);


		Teclado();

		if(GetTime() - nLastMoveTime < nJuegoSpeed)
			continue;

		nLastMoveTime = GetTime();
		tiempoJuego++;

		if(tiempoJuego % (nJuegoSpeed > 25 ? 20 : 40) == 0)
		{
			if(nJuegoSpeed > 15)
				nJuegoSpeed -= 2;
		}

		for (i = 0; i < 7; i++)
		{
			if (enemigos[i].enemDirBuena == Direccion_Der && personaje.pX > enemigos[i].eX && personaje.pY == enemigos[i].eY && aBackgroundTiles[enemigos[i].eX+1][enemigos[i].eY] != TileTipo_Pared)
			{
				enemigos[i].posXFijada = personaje.pX;
				enemigos[i].posYFijada = personaje.pY;
			}

			else if (enemigos[i].enemDirBuena == Direccion_Izq && personaje.pX < enemigos[i].eX && personaje.pY == enemigos[i].eY  && aBackgroundTiles[enemigos[i].eX-1][enemigos[i].eY] != TileTipo_Pared)
			{
				enemigos[i].posXFijada = personaje.pX;
				enemigos[i].posYFijada = personaje.pY;
			}

			else if (enemigos[i].enemDirBuena == Direccion_Arriba && personaje.pX == enemigos[i].eX && personaje.pY < enemigos[i].eY  && aBackgroundTiles[enemigos[i].eX][enemigos[i].eY-1] != TileTipo_Pared)
			{
				enemigos[i].posXFijada = personaje.pX;
				enemigos[i].posYFijada = personaje.pY;
			}

			else if (enemigos[i].enemDirBuena == Direccion_Abajo && personaje.pX == enemigos[i].eX && personaje.pY > enemigos[i].eY  && aBackgroundTiles[enemigos[i].eX][enemigos[i].eY+1] != TileTipo_Pared)
			{
				enemigos[i].posXFijada = personaje.pX;
				enemigos[i].posYFijada = personaje.pY;
			}


			if (enemigos[i].posXFijada == 0)
			{	
				if (EnemigoIA(i))
					EnemigoMover(i);
			}

			else
			{	
				EnemigoMover(i);
			}

			if (enemigos[i].enemDirBuena == Direccion_Der && aBackgroundTiles[enemigos[i].eX + 1][enemigos[i].eY] == TileTipo_Pared)
			{
				enemigos[i].posXFijada = 0;
				enemigos[i].posYFijada = 0;
			}
			else if (enemigos[i].enemDirBuena == Direccion_Izq && aBackgroundTiles[enemigos[i].eX - 1][enemigos[i].eY] == TileTipo_Pared)
			{
				enemigos[i].posXFijada = 0;
				enemigos[i].posYFijada = 0;
			}
			else if (enemigos[i].enemDirBuena == Direccion_Arriba && aBackgroundTiles[enemigos[i].eX][enemigos[i].eY - 1] == TileTipo_Pared)
			{
				enemigos[i].posXFijada = 0;
				enemigos[i].posYFijada = 0;
			}
			else if (enemigos[i].enemDirBuena == Direccion_Abajo && aBackgroundTiles[enemigos[i].eX][enemigos[i].eY + 1] == TileTipo_Pared)
			{
				enemigos[i].posXFijada = 0;
				enemigos[i].posYFijada = 0;
			}

			if (enemigos[i].eX == personaje.pX && enemigos[i].eY == personaje.pY)
				salirJuego = 1;
		}


		if (salirJuego == 1)
			break;

		if(!MoverPj())
			break;

		countdown--;

		SetCursor(1,1);
		if(countdown>=100)
			printf("Score: %d Time: %d", puntos, countdown);
		else if(countdown>=10)
			printf("Score: %d Time: 0%d", puntos, countdown);
		else
			printf("Score: %d Time: 00%d", puntos, countdown);

		if(countdown <= 0){
			break;
		}
	}

	SetMode(1);

	SetCursor(9, 7);
	printf("Total playtime: %d", tiempoJuego);

	SetCursor(8, 14);
	printf("Press Enter to play again");


	SetCursor(14,21);
	printf("Score: %d", puntos);


	while(GetChar() != 13) {}
}

//MostrarIntro
void MostrarIntro()
{
	unsigned int pX = 20;
	unsigned int pY = 30;
	const unsigned char BlackPalette[16] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	unsigned char *pScreen = (unsigned char *)0xC000 + ((pY / 8) * 80) + ((pY % 8) * 2048) + pX;
	unsigned char *pSprite = (unsigned char *)SpriteCroconauts;

	InitMode0();

	SetPalette(BlackPalette);

	PutSpriteMode0(pScreen, 80 / 2, 80, pSprite);

	SetPalette(CroconautsPalette);

	SetCursor(6, 18);
	printf("Croconauts");
	SetCursor(10, 25);
	printf("presents...");

	while (!GetChar()) {}
}

//MostrarIntroCleptrojan
void MostrarIntroCleptrojan()
{
	unsigned int pX = 0;
	unsigned int pY = 0;
	const unsigned char BlackPalette[16] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	unsigned char *pScreen = (unsigned char *)0xC000 + ((pY / 8) * 80) + ((pY % 8) * 2048) + pX;
	unsigned char *pSprite = (unsigned char *)SpriteCleptrojan;

	InitMode0();

	SetPalette(BlackPalette);

	PutSpriteMode0(pScreen, 160 / 2, 200, pSprite);

	SetPalette(CleptrojanPalette);

	while (!GetChar()) {}
}

//MostrarInstrucciones
void MostrarInstrucciones()
{
	SetMode(1);
	SetPalette(CroconautsPalette);

	SetCursor(14, 1);
	printf("CLEPTROJAN");

	SetCursor(5, 6);
	printf("Use cursors or 'opqa' to move ");
	SetCursor(13, 7);
	printf("the cleptrojan");

	SetCursor(5, 9);
	printf("Steal the GOLDEN CHIP and run ");
	SetCursor(13, 10);
	printf("to the exit!");

	SetCursor(5, 12);
	printf("Use the WARP PORTALS to travel");
	SetCursor(13, 13);
	printf("around the map");

	SetCursor(3, 15);
	printf("Those antivirus wants to catch you");
	SetCursor(13, 16);
	printf("Be careful!");

	SetCursor(9, 20);
	printf("Press Enter to start");

	SetCursor(11, 25);
	printf("Croconauts - 2013");

	while(GetChar() != 13) {}
}

//GetTime()
unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
	CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
		__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}

//GetChar()
char GetChar()
{
	__asm
	LD HL, #_nGetChar
		LD (HL), #0
		CALL #0xBB09 ;KM READ CHAR
		JP NC, _end_getchar
		LD (HL), A
_end_getchar:
	__endasm;

	return nGetChar;
}

//PutSpriteMode0()
void PutSpriteMode0(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite)
{
	__asm
	LD L, 4(IX) 
		LD H, 5(IX) 
		LD C, 6(IX) 
		LD B, 7(IX)            
		LD E, 8(IX) 
		LD D, 9(IX) 

_loop_alto:
	PUSH BC
		LD B,C
		PUSH HL
_loop_ancho:
	LD A,(DE)
		LD (HL),A
		INC DE
		INC HL
		DJNZ _loop_ancho
		POP HL
		LD A,H
		ADD #0x08
		LD H,A
		SUB #0xC0
		JP NC, _sig_linea
		LD BC, #0xC050
		ADD HL,BC
_sig_linea:
	POP BC
		DJNZ _loop_alto
		__endasm;
}

//DrawTile
void DrawTile(unsigned char nTileX, unsigned char nTileY)
{
	enum TileTipo tileTipo = aBackgroundTiles[nTileX][nTileY];

	unsigned int pY = nTileY * TILE_ALTURA;
	unsigned int pX = nTileX * TILE_ANCHURA;
	unsigned char *pScreen = (unsigned char *)0xC000 + ((pY / 8) * 80) + ((pY % 8) * 2048) + (pX / 2);
	unsigned char *pSprite = (unsigned char *)SpriteGround;

	switch(tileTipo)
	{
	case TileTipo_Chip:
		pSprite = (unsigned char *)SpriteChip;
		break;
	case TileTipo_EnemMiraArriba:
		pSprite = (unsigned char *)SpriteEnemHeadUp;
		break;
	case TileTipo_EnemMiraAbajo:
		pSprite = (unsigned char *)SpriteEnemHeadDown;
		break;
	case TileTipo_EnemMiraIzq:
		pSprite = (unsigned char *)SpriteEnemHeadLeft;
		break;
	case TileTipo_EnemMiraDer:
		pSprite = (unsigned char *)SpriteEnemHeadRight;
		break;
	case TileTipo_PjMiraArriba:
		pSprite = (unsigned char *)SpritePlayerHeadUp;
		break;
	case TileTipo_PjMiraAbajo:
		pSprite = (unsigned char *)SpritePlayerHeadDown;
		break;
	case TileTipo_PjMiraIzq:
		pSprite = (unsigned char *)SpritePlayerHeadLeft;
		break;
	case TileTipo_PjMiraDer:
		pSprite  = (unsigned char *)SpritePlayerRight;
		break;
	case TileTipo_Vacio:
		pSprite = (unsigned char *)SpriteBlack;
		break;
	case TileTipo_Pared:
		pSprite  = (unsigned char *)SpriteWall;
		break;
	case TileTipo_Suelo:
		pSprite  = (unsigned char *)SpriteGround;
		break;
	case TileTipo_Portal:
		pSprite  = (unsigned char *)SpritePortal;
		break;
	}

	PutSpriteMode0(pScreen, TILE_ANCHURA / 2, TILE_ALTURA, pSprite);
}

//SetColor
void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
	__asm
	ld a, 4 (ix)
		ld b, 5 (ix)
		ld c, b
		call #0xBC32 ;SCR SET INK
		__endasm;
}

//SetMode
void SetMode(unsigned char nMode)
{
	__asm
	ld a, 4 (ix)
		call #0xBC0E ;SCR_SET_MODE
		__endasm;
}

//SetCursor
void SetCursor(unsigned char nColum, unsigned char nLine)
{
	__asm
	ld h, 4 (ix)
		ld l, 5 (ix)
		call #0xBB75 ;TXT SET CURSOR
		__endasm;
}

//SetPalette
void SetPalette(const unsigned char *pPalette)
{
	unsigned char nColor = 0;

	for (nColor = 0; nColor < 16; nColor++)
		SetColor(nColor, pPalette[nColor]);
}

//InitMode0
void InitMode0()
{
	SetMode(0);

	//SCR SET BORDER 0
	__asm
	ld b, #0 ;black
		ld c, b
		call #0xBC38
		__endasm;
}